// String prototype to facilitate data exchange
String.prototype.escString=function() {
  return this.replace(/\\/g, "\\\\").replace(/"/g, '\\"');
}

//Called when application is started.
function OnStart() {
  // Create basic layout
  lay = app.CreateLayout( "linear", "VLeft,FillXY" );

  // Add the WebView
  web = app.CreateWebView( 1.0, 0.6 );
  lay.AddChild( web );

  // Add droidscript app text input elements. These correspond to
  // the text inputs in the webview...
  txtItem1 = app.CreateText( "Item 1:", null, null, "Left" );
  lay.AddChild( txtItem1 );
  tedItem1 = app.CreateTextEdit( "Item 1 in app",
    0.5, null, "Left" );
  lay.AddChild( tedItem1 );

  txtItem2 = app.CreateText( "Item 2:", null, null, "Left" );
  lay.AddChild( txtItem2 );
  tedItem2 = app.CreateTextEdit( "Item 2 in app",
    0.5, null, "Left" );
  lay.AddChild( tedItem2 );

  // Button to send data in TextEdits to the WebView...
  btnSend = app.CreateButton( "Touch to Send Data to WebView" );
  btnSend.SetOnTouch( btnSend_OnTouch );
  lay.AddChild( btnSend );

  app.AddLayout( lay );

  // Load the html form into the WebView
  web.LoadUrl( "webform.html" );
}

// Send the data in the TextEdits to the WebView...
function btnSend_OnTouch() {
  var rec = {};
  rec.item1 = tedItem1.GetText();
  rec.item2 = tedItem2.GetText();
  web.Execute(
    "ReceiveAppData(\"" + JSON.stringify(rec).escString() + "\");" 
  );  // ^^^^^^^^^ this global function must be defined in webview script
}

// Receive data from the WebView and insert into the TextEdits...
function ReceiveWebviewData( rec ) {
  rec = JSON.parse(rec);
  tedItem1.SetText( rec.item1 );
  tedItem2.SetText( rec.item2 );
}
